######################################################################
# counter.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id$
#
# "PyukiWiki" version 0.1.6-beta1 $$
# Author: Nekyo
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2004 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-106 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL v2 and/or Artistic v1 or any later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

sub plugin_counter_inline {
	my $arg = shift;
#	my %counter = plugin_counter_get_count($::form{mypage});
	my %counter = plugin_counter_get_count($::form{basepage} ne '' ? $::form{basepage} : $::form{mypage});
	my $count;
	if ($arg =~/(today|yesterday)/i) {
		$count = $counter{$arg};
	} else {
		$count = $counter{'total'}
	}
	return " $count";
}

sub plugin_counter_convert {
#	my %counter = plugin_counter_get_count($::form{mypage});
	my %counter = plugin_counter_get_count($::form{basepage} ne '' ? $::form{basepage} : $::form{mypage});
	return <<"EOD";
<div class="counter">
Counter: $counter{'total'},
today: $counter{'today'},
yesterday: $counter{'yesterday'}
</div>
EOD
}

sub plugin_counter_get_count {
	my $page = shift;

	my ($mday, $mon, $year) = (localtime(time))[3..5];
	$year += 1900;
	$mon += 1;
	my $date = "$year/$mon/$mday";

	my %default = (
		'total'     => 0,
		'date'      => $date,
		'today'     => 0,
		'yesterday' => 0,
		'ip'        => ''
	);

	my %counter = %default;

	if (!&is_exist_page($page)) {
		return %default;
	}

	my $file = $::counter_dir . "/" . &encode($page) . $::counter_ext;

	my @keys = keys(%default);
	my $modify = 0;
	if (-e $file) {
		open(FILE, "+<$file") or return "Counter Conflict.<br />\n";
		flock(FILE, 2);
		foreach my $key (@keys) {
			$_ = <FILE>;
			chomp;
			$counter{$key} = $_;
		}
	} else {
		open(FILE, ">$file") or return "Counter Conflict.<br />\n";
		flock(FILE, 2);
		$counter{'date'} = "";
	}

	if ($counter{'date'} ne $default{'date'}) {
		$modify = 1;
		$counter{'ip'}        = $ENV{'REMOTE_ADDR'};
		# v0.1.6 ̃ANZXȂꍇ
#		$counter{'yesterday'} = $counter{'today'};
		my ($_mday, $_mon, $_year) = (localtime(time-86400))[3..5];
		$_year += 1900;
		$_mon += 1;
		my $_date = "$_year/$_mon/$_mday";
		if($counter{'date'} eq $_date) {	# ̓tȂۑ
			$counter{'yesterday'} = $counter{'today'};
		} else {
			$counter{'yesterday'} = $default{'yesterday'};
		}
		$counter{'date'}      = $default{'date'};
		$counter{'today'}     = 1;
		$counter{'total'}++;
	} elsif ($counter{'ip'} ne $ENV{'REMOTE_ADDR'}) {
		$modify = 1;
		$counter{'ip'}        = $ENV{'REMOTE_ADDR'};
		$counter{'today'}++;
		$counter{'total'}++;
	}

	if ($modify == 1) {
		if (FILE) {
			truncate(FILE, 0);
			seek(FILE, 0, 0);
		} else {
			open(FILE, ">$file") or return "Counter Conflict.<br />\n";
			flock(FILE, 2);
		}
		foreach my $key (@keys) {
			print FILE $counter{$key} . "\n";
		}
	}
	if (FILE) {
		flock(FILE, 8);
		close(FILE);
	}
	return %counter;
}
1;
__END__
=head1 NAME

counter.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 #counter
 &counter(total);
 &counter(today);
 &counter(yesterday);

=head1 DESCRIPTION

Access counter

=head1 USAGE

=over 4

=item #counter

View all counter value

=item &counter(total);

Total of counter, page reference is displayed.

=item &counter(today);

Count of page reference display, a part for today.

=item &counter(yesterday);

Count of page reference display, a part for yesterday.

=back

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/counter

L<http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/Standard/counter/>

=item PyukiWiki CVS

L<http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/pyukiwiki/PyukiWiki-Devel/plugin/counter.inc.pl>

=back

=head1 AUTHOR

=over 4

=item Nekyo

L<http://nekyo.hp.infoseek.co.jp/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=back

=head1 LICENSE

Copyright (C) 2004-106 by Nekyo.

Copyright (C) 2005-106 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2 and/or Artistic v1 or later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
