######################################################################
# perlpod.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id$
#
# "PyukiWiki" version 0.1.6-beta1 $$
# Author: Nanami
# http://lineage.netgamers.jp/
# Copyright (C) 2004 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-106 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL v2 and/or Artistic v1 or any later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

sub plugin_perlpod_action {
	my $file;
	$file=$::form{file};
	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);
	return('msg'=>"\t$::$file"
		,'body'=>&perlpod($file));
}

sub plugin_perlpod_convert {
	my $file;

	my @args=split(/,/,shift);
	$file=$args[0];
	$notitle=$args[1];

	return if($file=~/\.\./ || $file=~/^\// || $file=~/[|><%'"]/);

	return(&perlpod($file,$notitle ne '' ? "notitle" : ""));
}

sub getperlpath{
	my $perlpath;
	if(open(R,"$0")) {
		$perlpath=<R>;
		close(R);
		$perlpath=~s/#!//g;
		$perlpath=~s/-//g;
		$perlpath=~s/ //g;
		$perlpath=~s/[\r\n]//g;
		return $perlpath;
	}
	return '';
}

sub perlpod {
	my($file,$notitle)=@_;
	$file=~s/.*\///g;

	foreach my $dirs($::data_home, $::data_pub, $::explugin_dir, $::plugin_dir
			, $::res_dir, $::skin_dir, $::image_dir) {
		if(-r "$dir/$file") {
			return &perlpod_sub("$dir/$file",$notitle);
		}
	}
	foreach my $dirs($::explugin_dir, $::plugin_dir, $::res_dir, $::skin_dir, $::data_home, $::data_pub) {
		my $ret=&perlpod_sub2($dirs,$file);
		if($ret ne '') {
			return &perlpod_sub($ret,$notitle);
		}
	}
	return("File nod found:$file");
}

my $level=0;

sub perlpod_sub2 {
	my($dir,$file)=@_;

	opendir(DIR,$dir);
	my @files=readdir(DIR);
	closedir(DIR);

	foreach(@files) {
		next if($_ eq '.' || $_ eq '..');
		my $path="$dir/$_";
		return $path if($_ eq $file);
		if(-d $path) {
			$level++;
			return '' if($level > 10);
			my $ret=&perlpod_sub2($path,$file);
			return $ret if($ret ne '');
			$level--;
		}
	}
	return "";
}

sub perlpod_sub {
	use Pod::Html;
	my $perlpath=&getperlpath;
	my $file=shift;
	my $notitle=shift;

	my $pod;
	my $tmp;
	return("perl path can't found") if($perlpath eq '');

	return("File not found : $file") unless(-r $file);

	if($ENV{TEMP} ne '') {
		$tmp=$ENV{TEMP};
	} elsif($ENV{TMP} ne '') {
		$tmp=$ENV{TMP};
	} else {
		$tmp="/tmp";
	}

	my $exec="$perlpath -S pod2html -cachedir=$tmp $file";
	if(open(PIPE,"$exec |")) {
		foreach(<PIPE>) {
			$pod.=$_;
		}
		close(PIPE);
	} else {
		return("Can't exec $exec");
	}
	my $body;
	foreach(split(/\n/,$pod)) {
		s/^<!.*//g;
		s/<(html|\/html).*//g;
		s/<(body|\/body).*//g;
		s/<(link|\/link).*//g;
		s/<\/h4>/<\/h6>/g;
		s/<\/h3>/<\/h5>/g;
		s/<\/h2>/<\/h4>/g;
		s/<\/h1>/<\/h3>/g;
		s/<\/title>/<\/h2>/g;
		s/<h4>/<h6>/g;
		s/<h3>/<h5>/g;
		s/<h2>/<h4>/g;
		s/<h1>/<h3>/g;
		s/<title>/<h2>/g;
		next if($_ eq '');
		next if($notitle ne '' && /<h2.*>/);
		$body.="$_\n";
	}
	return($body);
}

1;
__END__

