######################################################################
# pyukiwiki.skin.ja.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: pyukiwiki.skin.ja.cgi,v 1.18 2006/01/25 00:59:18 papu Exp $
#
# "PyukiWiki" version 0.1.6-beta2-p1 $$
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

sub skin {
	my ($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $basehref) = @_;

	my($page,$message,$errmessage)=split(/\t/,$pagename);	
	my $cookedpage = &encode($page);
	my $cookedurl=&make_cookedurl($cookedpage);
	my $escapedpage = &htmlspecialchars($page);
	my $HelpPage = &encode($::resource{help});
	my $htmlbody;

	if ($::last_modified != 0) {	# v0.0.9
		$lastmod = &date($::lastmod_format, (stat($::data_dir . "/" . &dbmname($page) . ".txt"))[9]);
	}

	if($::lang eq 'ja') {
		$csscharset=qq(" charset="Shift_JIS");
	}
	if($::use_blosxom eq 1) {
		$::IN_HEAD.=<<EOD;
<link rel="stylesheet" href="$::skin_url/blosxom.css" type="text/css" media="screen"$csscharset />
EOD
	}

	#v0.1.6
	if($::form{cmd}=~/edit|admin|diff|attach/) {
		$robot=<<EOD;
<meta name="robots" content="noindex,nofollow,noarchive">
<meta name="googlebot" content="noindex,nofollow,noarchive">
EOD
	} else {
		$robot=<<EOD;
<meta name="robots" content="index,follow">
<meta name="googlebot" content="index,follow,archive"> 
EOD
	}
	if($::wiki_title ne '') {
		$title="$::wiki_title - ";
	}

	if($page eq '') {
		$title_tag="$title$message";
	} else {
		$title_tag="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}";
	}

	$htmlbody=<<"EOD";
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="$::lang">
<head>
<meta http-equiv="Content-Language" content="$::lang">
<meta http-equiv="Content-Type" content="text/html; charset=$::charset">
<title>$title_tag</title>
@{[$basehref eq '' ? '' : qq(<base href="$basehref">)]}
<link rel="stylesheet" href="$::skin_url/default.$::lang.css" type="text/css" media="screen"$csscharset />
<link rel="stylesheet" href="$::skin_url/print.$::lang.css" type="text/css" media="print"$csscharset />
@{[$::AntiSpam ne "" ? '' : qq(<link rev="made" href="mailto:$::modifier_mail">)]}
<link rel="top" href="$::script">
<link rel="index" href="$::script?cmd=list">
@{[$::use_SiteMap eq 1 ? qq(<link rel="contents" href="$::script?cmd=sitemap">) : '']}
<link rel="search" href="$::script?cmd=search">
<link rel="help" href="$::script?$HelpPage">
<meta name="description" content="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}">
<meta name="author" content="$::modifier">
<meta name="copyright" content="$::modifier">
$robot
<script type="text/javascript" src="$::skin_url/common.$::lang.js"></script>
$::IN_HEAD
</head>
<body class="$bodyclass">
<div id="header">
 <a href="$::modifierlink"><img id="logo" src="$::image_url/pyukiwiki.png" width="80" height="80" alt="[PyukiWiki]" title="[PyukiWiki]" /></a>
EOD
	if($errmessage ne '') {
		$htmlbody.=<<EOD;
<h1 class="error">$errmessage</h1>
<a href="$cookedurl">$basehref?$cookedpage</a>
EOD
	} elsif($page ne '') {
		$htmlbody.=<<EOD;
<h1 class="title"><a
    title="$::resource{searchthispage}"
    href="$::script?cmd=search&amp;mymsg=$cookedpage">@{[&htmlspecialchars($page)]}</a>@{[$message eq '' ? '' : "&nbsp;$message"]}</h1>
<span class="small"><a href="$cookedurl">$basehref?$cookedpage</a></span>
EOD
	} else {
		$htmlbody.=<<EOD;
<h1 class="title">$message</h1>
EOD
	}
	$htmlbody.=<<EOD;
</div>
<div id="navigator">

 [ <a href="$cookedurl">$::resource{reload}</a> ]
 &nbsp;
 [ <a href="$::script?cmd=newpage&refer=$cookedpage">$::resource{createbutton}</a>
 @{[ $editable
   ? qq( | <a title="$::resource{editthispage}" href="$::script?cmd=edit&amp;mypage=$cookedpage">$::resource{editbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a title="$::resource{admineditthispage}" href="$::script?cmd=adminedit&amp;mypage=$cookedpage">$::resource{admineditbutton}</a>)
   : qq()
 ]}
 @{[ $admineditable
   ? qq( | <a href="$::script?cmd=diff&amp;mypage=$cookedpage">$::resource{diffbutton}</a>)
   : qq()
 ]}
 @{[ (-f "$::plugin_dir/attach.inc.pl" && $::file_uploads > 0)
   ? qq( | <a href="$::script?cmd=attach&amp;mypage=$cookedpage">$::resource{attachbutton}</a>)
   : qq()
 ]}
 ]
 &nbsp;
 [ <a href="$::script?$::FrontPage">$::resource{top}</a> | 
   <a href="$::script?cmd=list">$::resource{indexbutton}</a> | 
 @{[ $::use_SiteMap eq 1
   ? qq(<a href="$::script?cmd=sitemap">$::resource{sitemapbutton}</a> | )
   : qq()
 ]}
   <a href="$::script?cmd=search">$::resource{searchpage}</a> |
   <a href="$::script?cmd=recent">$::resource{recentchangesbutton}</a> |
   <a href="$::script?$HelpPage">$::resource{help}</a> ]
</div>
<hr class="full_hr" />
@{[ $::last_modified == 1
  ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
  : q()
]}
EOD

	if ($is_page || $::allview eq 1) {
		if (&is_exist_page($::Header)) {
			$htmlbody.="<div id=\"pageheader\">";
			$htmlbody.=&print_content($::database{$::Header}, $::form{mypage});
			$htmlbody.= "</div>";
		}

		$htmlbody.= <<"EOD";
<table border="0" style="width:100%">
  <tr>
    <td class="menubar">
    <div id="menubar">
EOD
		$::pushedpage = $::form{mypage};	# push;
		$::form{mypage} = $::MenuBar;
		#v0.1.6
		$htmlbody.=&print_content($::database{$::form{mypage}},$pushedpage);
		$::form{mypage} = $::pushedpage;	# pop
		$::pushedpage='';

		$htmlbody.= <<"EOD";
    </div>
    </td>
    <td valign=top>
      <div id="body">$body</div>
    </td>
  </tr>
</table>
EOD
		if (&is_exist_page($::Footer)) {
			$htmlbody.= "<div id=\"pagefooter\">";
			$htmlbody.=&print_content($::database{$::Footer}, $::form{mypage});
			$htmlbody.= "</div>";
		}
	} else {
		$htmlbody.= <<"EOD";
<div id="body">$body</div>
EOD
	}

	if (@::notes) {
		$htmlbody.= << "EOD";
<div id="note">
<hr class="note_hr" />
EOD
		my $cnt = 1;
		foreach my $note (@::notes) {
			$htmlbody.= << "EOD";
<a id="notefoot_$cnt" href="@{[&make_cookedurl($::form{mypage})]}#notetext_$cnt" class="note_super">*$cnt</a>
<span class="small">@{[&inline($note)]}</span>
<br />
EOD
			$cnt++;
		}
		$htmlbody.="</div>\n";
	}


	$htmlbody.= <<"EOD";
<hr class="full_hr" />
<div id="toolbar"><a href="$::script?cmd=rss10"><img src="$::image_url/rss.png" border="0" /></a></div>
@{[ $::last_modified == 2
 ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
 : qq()
]}
<div id="footer">
EOD

	# y[Wtb^ wiki@
	my $footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
~
''[[PyukiWiki $::version>http://pyukiwiki.sourceforge.jp/]]''
Copyright&copy; 2004-2006 by [[Nekyo>http://nekyo.hp.infoseek.co.jp/]], [[PyukiWiki Developers Team>http://pyukiwiki.sourceforge.jp/]]
License is [[GPL>@{[$::lang eq 'ja' ? 'http://www.opensource.jp/gpl/gpl.ja.html' : 'http://www.gnu.org/licenses/gpl.html']}]], 
[[Artistic>@{[$::lang eq 'ja' ? 'http://www.opensource.jp/artistic/ja/Artistic-ja.html' : 'http://www.perl.com/language/misc/Artistic.html']}]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sourceforge.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sourceforge.jp/]]
EOD
	$htmlbody.= &text_to_html($footerbody);
	$htmlbody.= <<"EOD";
<!--HTMLEND-->
</div>
</body>
</html>
EOD
	return $htmlbody;
}

1;
