######################################################################
# counter.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: counter.inc.pl,v 1.15 2006/01/25 00:59:18 papu Exp $
#
# "PyukiWiki" version 0.1.6-beta2-p1 $$
# Author: Nekyo
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################

use strict;
use Nana::Lock;

sub plugin_counter_inline {
	my $arg = shift;
	my %counter = plugin_counter_get_count($::form{basepage} ne '' ? $::form{basepage} : $::form{mypage});
	my $count;
	if ($arg =~/(today|yesterday)/i) {
		$count = $counter{$arg};
	} else {
		$count = $counter{'total'}
	}
	return " $count";
}

sub plugin_counter_convert {
	my %counter = plugin_counter_get_count($::form{basepage} ne '' ? $::form{basepage} : $::form{mypage});
	return <<"EOD";
<div class="counter">
Counter: $counter{total},
today: $counter{today},
yesterday: $counter{yesterday}
</div>
EOD
}

my %default = (
	'total'     => 0,
	'date'      => '',
	'today'     => 0,
	'yesterday' => 0,
	'ip'        => ''
);

sub plugin_counter_get_count {
	my $page = shift;

	if (!&is_exist_page($page)) {
		return %default;
	}
	return &plugin_counter_do($page,"w");
}

sub plugin_counter_do {
	my($page,$rw)=@_;
	$rw="r" if($rw=~/[Rr]/);
	my %counter = %default;

	my $file = $::counter_dir . "/" . &encode($page) . $::counter_ext;

	my ($mday, $mon, $year) = (localtime)[3..5];
	$year += 1900;
	$mon += 1;
	$default{date}="$year/$mon/$mday";

	my @keys = keys(%default);
	my $modify = 0;

	my $counters=Nana::Lock::lock_fetch($file);
	my $buf;
	foreach my $key(@keys) {
		$buf=$counters;
		$buf=~s/\n.*//g;
		$counters=~s/^.*?\n//;
		chomp $buf;
		$counter{$key} = $buf;
	}

	if ($counter{date} ne $default{date}) {
		$modify = 1;
		$counter{ip}=$ENV{REMOTE_ADDR};
		my ($_mday, $_mon, $_year) = (localtime(time-86400))[3..5];
		$_year += 1900;
		$_mon += 1;
		my $_date = "$_year/$_mon/$_mday";
		if($counter{date} eq $_date) {	# ̓tȂۑ
			$counter{yesterday} = $counter{today};
		} else {
			$counter{yesterday} = $default{yesterday};
		}
		$counter{date}      = $default{date};
		$counter{today}     = ($rw eq 'r' ? 0 : 1);
		$counter{total}++ if($rw ne 'r');
	} elsif ($counter{ip} ne $ENV{REMOTE_ADDR}) {
		$modify = 1;
		$counter{ip}        = $ENV{REMOTE_ADDR};
		$counter{today}++ if($rw ne 'r');
		$counter{total}++ if($rw ne 'r');
	}

	if($modify eq 1 && $rw ne 'r') {
		$buf="";
		foreach my $keys(@keys) {
			$buf.="$counter{$keys}\n";
		}
		Nana::Lock::lock_store($file,$buf);
	}
	close(FILE);
	return %counter;
}
1;
__END__
