######################################################################
# clipcopy.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: clipcopy.pl,v 1.12 2006/01/30 23:16:26 papu Exp $
#
# "PyukiWiki" version 0.1.6-beta4-p3 $$
# Author: Nanami http://lineage.netgamers.jp/
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################
# clipcopy ץ饰
# IEѤΥץ饰ǡåƥ硼ȥåȤ򥳥ԡΤ
# 󥯥åǤǤ褦ˤΤǤ
# IEʳǤϡϤޤ
#
# usage : &clipcopy(url, text);
######################################################################

use strict;
package clipcopy;

sub plugin_inline {
	my ($arg)=@_;
	my ($linkurl,$text,$copiedtext)=split(/,/,$arg);

	my $body;

	$text=&::javascriptspecialchars($text);
	$linkurl=&::javascriptspecialchars($linkurl);


	if($ENV{HTTP_USER_AGENT}=~/MSIE/ && $ENV{HTTP_USER_AGENT}!~/Opera/) {
		return " " if($linkurl!~/$::isurl/);
		if($copiedtext eq '') {
			$copiedtext="$linkurl copied to clipboard";
		} else {
			$copiedtext=&::javascriptspecialchars($copiedtext);
		}
		$body=<<EOM;
(<a href="javascript:void(0);" title="$linkurl" onclick="clipboardData.setData('Text', '$linkurl');alert('$copiedtext')">$text</a>)
EOM
		return $body;
	}
	return " ";
}
1;
__END__
=head1 NAME

clipcopy.pl - PyukiWiki / YukiWiki Plugin

=head1 SYNOPSIS

 &clipcopy(linkurl, text, [copiedtext]);
 &clipcopy(http://pyukiwiki.sourceforge.jp/cgi-bin/w?rss
  ,RSS Link Copy,http://pyukiwiki.sourceforge.jp/cgi-bin/w?rss Copied to clipboard);

=head1 DESCRIPTION

Specified URL is copied to a clipboard. Any character strings other than URL cannot be specified.

Only Internet Explorer.
Nothing is returned in the other browser.

This plugin is compatible with YukiWiki.

=back

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/clipcopy

L<http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/Standard/clipcopy/>

=item PyukiWiki CVS

L<http://cvs.sourceforge.jp/cgi-bin/viewcvs.cgi/pyukiwiki/PyukiWiki-Devel/plugin/clipcopy.pl>

=back

=head1 AUTHOR

=over 4

=item Nanami

L<http://lineage.netgamers.jp/> etc...

=item PyukiWiki Developers Team

L<http://pyukiwiki.sourceforge.jp/>

=back

=head1 LICENSE

Copyright (C) 2005-2006 by Nanami.

Copyright (C) 2005-2006 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 2 and/or Artistic 1 or each later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
