######################################################################
# gzip.inc.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: gzip.inc.pl,v 1.14 2006/01/30 23:16:26 papu Exp $
#
# "PyukiWiki" version 0.1.6-beta4-p3 $$
# Author: Nanami http://lineage.netgamers.jp/
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return Code:LF Japanese Code=EUC 1TAB=4Spaces
######################################################################
# This is extented plugin.
# To use this plugin, rename to 'gzip.inc.cgi'
######################################################################

#$::gzip_path="/bin/gzip";
#$::gzip_path="/usr/bin/gzip";
#$::gzip_path="/usr/bin/gzip -1 -f";

$gzip_command="gzip";

sub plugin_gzip_init {
	# auto search too slow...
	if($::gzip_path eq '') {
		my $forceflag="";
		my $fastflag="";
		foreach(split(/:/,$ENV{PATH})) {
			if(-x "$_/$gzip_command") {
				$::gzip_path="$_/$gzip_command" ;
				if(open(PIPE,"$::gzip_path --help 2>&1|")) {
					foreach(<PIPE>) {
						$forceflag="--force" if(/(\-\-force)/);
						$fastflag="--fast" if(/(\-\-fast)/);
					}
					close(PIPE);
				}
			}
		}
		$gzip_path="$::gzip_path $fastflag $forceflag";
	}
	if ($::gzip_path ne '') {
		if(($ENV{'HTTP_ACCEPT_ENCODING'}=~/gzip/)) {
			if($ENV{'HTTP_ACCEPT_ENCODING'}=~/x-gzip/) {
				$::gzip_header="Content-Encoding: x-gzip\n";
			} else {
				$::gzip_header="Content-Encoding: gzip\n";
			}
		}
	}

	return('http_header'=>$::gzip_header,
		   'init'=>$::gzip_header eq '' ? 0 : 11,
		   'func'=>'content_output');
}

sub content_output {
	my ($http_header,$body)=@_;
	print $http_header;
	if ($::gzip_header ne '') {
		open(STDOUT,"| $::gzip_path");
		$body=~s/<!--HTMLEND-->/ Compressed<!--HTMLEND-->/g;
	}
	print $body;
}

1;
__DATA__
sub plugin_gzip_setup {
	return(
	'ja'=>'gzipk',
	'en'=>'Compress gzip',
	'use_cmd'=>'gzip',
	'setting_ja'=>'$::gzip_opts=k:-1,-5,-9/$::gzip_opts=ForcetO:,-f,-force';
	'setting_en'=>'$::gzip_opts=Compress Method:-1,-5,-9/$::gzip_opts=Force Flag:,-f,-force';
	'override'=>'content_output',
	'url'=>'http://pyukiwiki.sourceforge.jp/cgi-bin/w/PyukiWiki/Plugin/ExPlugin/gzip/'
	);
__END__

